--- /dev/null
+++ b/zipl/boot/eckd2dump_mv.c
@@ -0,0 +1,206 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Multi-volume ECKD DASD dump tool
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Michael Holzheu <holzheu@linux.vnet.ibm.com>
+ */
+
+#include "stage2dump.h"
+#include "eckd2dump.h"
+#include "error.h"
+
+#define MVDUMP_SIZE		0x3000	/* Size of dump record */
+#define MAX_DUMP_VOLUMES	32	/* Up to 32 dump volumes possible */
+
+/*
+ * Magic number at start of dump record
+ */
+uint64_t magic __attribute__((section(".stage2.head")))
+	= 0x5a4d554c54363403ULL; /* ZMULT64, version 3 */
+
+/*
+ * Parameter format for ECKD MV dumper (13 bytes):
+ *
+ * DDSS SSEE EEBN O
+ *
+ * - DD  : Devno of dump target
+ * - SSSS: Start block number of dump target
+ * - EEEE: End block number of dump target
+ * - B   : Blocksize of dump target (needs to be left-shifted by 8 bits)
+ * - N   : End Record Number
+ * - O   : Number of Heads of DASD
+ *
+ * We assume that the End Record Number is at track boundary.
+ * This allows us to determine the number of Blocks Per Track.
+ */
+struct mvdump_param {
+	uint16_t	devno;
+	uint32_t	blk_start;
+	uint32_t	blk_end;
+	uint8_t		blk_size;
+	uint8_t		bpt;
+	uint8_t		num_heads;
+} __packed;
+
+/*
+ * Provide storage for parameter table: 10 + 32*PTE_LENGTH = 426 bytes
+ * We take 512 bytes to match with struct mvdump_parm_table in include/boot.h
+ */
+struct mvdump_parm_table {
+	uint64_t	tod;
+	uint16_t	num_param;
+	struct mvdump_param param[MAX_DUMP_VOLUMES];
+	unsigned char	reserved[512 - sizeof(uint64_t) - sizeof(uint16_t) -
+			(MAX_DUMP_VOLUMES * sizeof(struct mvdump_param))];
+} __packed;
+
+static struct mvdump_parm_table mvdump_table
+	__attribute__((section(".eckd2dump_mv.tail")));
+
+static int volnr_current;
+
+/*
+ * Get device characteristics for current DASD device from zipl parameter block
+ */
+void dt_device_parm_setup(void)
+{
+	struct mvdump_param *param = &mvdump_table.param[volnr_current];
+
+	device.devno = param->devno;
+	device.blk_start = param->blk_start;
+	device.blk_end = param->blk_end;
+	device.blk_size = ((unsigned int) param->blk_size) << 8;
+	device.bpt = param->bpt;
+	device.num_heads = param->num_heads;
+	stage2dump_eckd_init();
+}
+
+/*
+ * Get subchannel ID for MV dump
+ */
+static int set_ssid_from_devno(uint16_t devno)
+{
+	struct subchannel_id ssid;
+	struct schib schib;
+
+	memset(&ssid, 0, sizeof(ssid));
+
+	ssid.one = 1;
+	ssid.sch_no = 0;
+	do {
+		if (store_subchannel(ssid, &schib) == 0) {
+			if (schib.pmcw.dev == devno) {
+				device.ssid = ssid;
+				break;
+			}
+		}
+		if (ssid.sch_no == 0xffff)
+			return -1;
+		ssid.sch_no++;
+	} while (1);
+	return 0;
+}
+
+/*
+ * Enable current DASD device
+ */
+void dt_device_enable(void)
+{
+	struct mvdump_param *param = &mvdump_table.param[volnr_current];
+
+	if (set_ssid_from_devno(param->devno) != 0)
+		panic(ENODEVNO, "%04x is undefined", param->devno);
+	io_irq_enable();
+	set_device(device.ssid, ENABLED);
+}
+
+/*
+ * Dump all memory to multiple DASD partitions
+ */
+void dt_dump_mem(void)
+{
+	unsigned long blk, addr, addr_end, blk_num, dev_mem_size, page;
+	struct mvdump_parm_table *mvdump_table_new;
+	struct df_s390_hdr *hdr_new;
+
+	dump_hdr->mvdump_sign = DF_S390_MAGIC;
+	dump_hdr->mvdump = 1;
+	addr = 0;
+
+	page = get_zeroed_page();
+	do {
+		printf("Dumping to: %04x", device.devno);
+
+		/*
+		 * Check whether parameter table on dump device has a valid
+		 * time stamp. The parameter table is located right behind
+		 * the dump tool, the corresponding block number is:
+		 *   MAGIC_BLOCK_OFFSET + (MVDUMP_TOOL_SIZE / blocksize)
+		 *   So dump tool starts on track 0, block 3
+		 */
+		mvdump_table_new = (void *) page;
+		readblock(3 + MVDUMP_SIZE / 0x1000,
+			  __pa(mvdump_table_new), m2b(0x1000));
+		/*
+		 * Check if time stamps match
+		 */
+		if (mvdump_table.tod != mvdump_table_new->tod)
+			panic(ENOTIME, "Inconsistent time stamps");
+
+		/*
+		 * Check if dump partition has a valid dump signature.
+		 * Bypass signature check if "--force" had been specified during
+		 * zipl -M.
+		 */
+		hdr_new = (void *) page;
+		if (!parm_tail.mvdump_force) {
+			readblock(device.blk_start, __pa(hdr_new), 1);
+			if (dump_hdr->magic != hdr_new->mvdump_sign)
+				panic(ENOSIGN, "Wrong signature");
+		}
+
+		/*
+		 * Write dump header
+		 */
+		blk = device.blk_start;
+		writeblock(blk, __pa(dump_hdr), m2b(DF_S390_HDR_SIZE), 0);
+		blk += m2b(DF_S390_HDR_SIZE);
+
+		dev_mem_size = b2m(device.blk_end - blk + 1);
+		addr_end = MIN(dump_hdr->mem_size, addr + dev_mem_size);
+
+		/*
+		 * Write memory
+		 */
+		memset((void *) page, 0, PAGE_SIZE);
+		while (addr < addr_end) {
+			blk_num = MIN(ECKD_BPWRT_MAX, device.blk_end - blk + 1);
+			blk_num = MIN(m2b(addr_end - addr), blk_num);
+			writeblock(blk, addr, blk_num, page);
+			progress_print(addr);
+			blk += blk_num;
+			addr += b2m(blk_num);
+		}
+		if (addr == dump_hdr->mem_size)
+			break;
+		/*
+		 * Switch to next volume if available
+		 */
+		dump_hdr->volnr += 1;
+		volnr_current++;
+		if (dump_hdr->volnr >= mvdump_table.num_param)
+			panic(EMEM, "Device too small");
+		dt_device_parm_setup();
+		set_device(device.ssid, DISABLED);
+		dt_device_enable();
+	} while (1);
+	progress_print(addr);
+	/*
+	 * Write end marker
+	 */
+	df_s390_em_page_init(page);
+	writeblock(blk, page, 1, 0);
+	free_page(page);
+}
--- /dev/null
+++ b/zipl/boot/eckd2dump_sv.c
@@ -0,0 +1,83 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Single-volume ECKD DASD dump tool
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Michael Holzheu <holzheu@linux.vnet.ibm.com>
+ */
+
+#include "stage2dump.h"
+#include "eckd2dump.h"
+#include "error.h"
+
+/*
+ * Magic number at start of dump record
+ */
+uint64_t magic __attribute__((section(".stage2.head"))) =
+	0x5a45434b44363403ULL; /* "ZECKD64", version 3 */
+
+/*
+ * ECKD parameter block passed by zipl
+ */
+struct eckd_dump_param {
+	uint32_t blk_start;
+	uint32_t blk_end;
+	uint16_t blk_size;
+	uint8_t num_heads;
+	uint8_t bpt;
+	char reserved[4];
+} __packed;
+
+/*
+ * Get device characteristics from zipl parameter block
+ */
+void dt_device_parm_setup(void)
+{
+	struct eckd_dump_param *parm = (void *) __stage2_desc;
+
+	device.blk_start = parm->blk_start;
+	device.blk_end = parm->blk_end;
+	device.blk_size = parm->blk_size;
+	device.num_heads = parm->num_heads;
+	device.bpt = parm->bpt;
+	device.ssid = IPL_SC;
+	stage2dump_eckd_init();
+}
+
+/*
+ * Enable DASD device
+ */
+void dt_device_enable(void)
+{
+	io_irq_enable();
+	set_device(device.ssid, ENABLED);
+}
+
+/*
+ * Dump all memory to DASD partition
+ */
+void dt_dump_mem(void)
+{
+	unsigned long blk, addr, page;
+
+	blk = device.blk_start;
+	page = get_zeroed_page();
+
+	/* Write dump header */
+	writeblock(blk, __pa(dump_hdr), m2b(DF_S390_HDR_SIZE), 0);
+	blk += m2b(DF_S390_HDR_SIZE);
+
+	/* Write memory */
+	for (addr = 0; addr < dump_hdr->mem_size; addr += b2m(ECKD_BPWRT_MAX)) {
+		writeblock(blk, addr, ECKD_BPWRT_MAX, page);
+		progress_print(addr);
+		blk += ECKD_BPWRT_MAX;
+	}
+	progress_print(addr);
+
+	/* Write end marker */
+	df_s390_em_page_init(page);
+	writeblock(blk, page, 1, 0);
+	free_page(page);
+}
--- /dev/null
+++ b/zipl/boot/entry.S
@@ -0,0 +1,18 @@
+/*
+ *  Entry module for stage 2 stand-alone dump tools
+ *
+ *  Copyright IBM Corp. 2001, 2013
+ *  Author(s): Michael Holzheu  <holzheu@linux.vnet.ibm.com>
+ */
+
+#define __LC_SAVE_AREA_SYNC	0x200	/* Save area for interrupts */
+#define __LC_PGM_OLD_PSW	0x0150	/* Program check old PSW */
+
+.globl pgm_check_handler
+pgm_check_handler:
+	stmg	%r0,%r15,__LC_SAVE_AREA_SYNC
+	aghi	%r15,-200
+	larl	%r14,pgm_check_handler_fn
+	basr	%r14,%r14
+	lmg	%r0,%r15,__LC_SAVE_AREA_SYNC
+	lpswe	__LC_PGM_OLD_PSW(%r0)
--- /dev/null
+++ b/zipl/boot/error.h
@@ -0,0 +1,68 @@
+/*
+ * zipl boot loader error codes
+ *
+ * Copyright IBM Corp. 2012
+ * Author(s): Michael Holzheu <holzheu@linux.vnet.ibm.com>
+ */
+
+#ifndef ERROR_H
+#define ERROR_H
+
+/************************************************************************
+ * zipl boot loader error codes (use decimal range 4500-4549)
+ *
+ * The error numbers are ABI. Do not change them!
+ ************************************************************************/
+
+/* I/O error: Enabling the IPL device failed */
+#define EENABLE_DEV		0x00004500
+
+/* I/O error: Disabling the IPL device failed */
+#define EDISABLE_DEV		0x00004501
+
+/* I/O error: The start subchannel command failed */
+#define ESSCH			0x00004502
+
+/* Internal error: The IPL type is incorrect */
+#define EWRONGTYPE		0x00004510
+
+/* Internal error */
+#define EINTERNAL		0x00004511
+
+/* kdump: No operating system information was found */
+#define EOS_INFO_MISSING	0x00004520
+
+/* kdump: The checksum of the operating system information is incorrect */
+#define EOS_INFO_CSUM_FAILED	0x00004521
+
+/* kdump: The major version of the operating system information is too high */
+#define EOS_INFO_VERSION	0x00004522
+
+/* kdump: No crashkernel memory was defined */
+#define EOS_INFO_NOCRASHKERNEL	0x00004523
+
+/* kdump: HSA copy failed */
+#define EHSA_COPY_FAILED	0x00004524
+
+/************************************************************************
+ * The following codes are not ABI
+ ************************************************************************/
+
+#define ETIMEOUT       2
+
+/*
+ * Stand-alone dump
+ */
+#define OK		0x00000000  /* Dump completed successfully */
+#define EMEM		0x00004600  /* Device too small for dump */
+#define EDEVNOTSUP	0x00004601  /* Device not supported */
+#define EMEMCOUNT	0x00004602  /* Could not evaluate memory layout */
+
+/*
+ * Multi-volume dump
+ */
+#define ENODEVNO	0x00004603  /* The devno does not exist */
+#define ENOSIGN		0x00004604  /* No valid dump signature on device */
+#define ENOTIME		0x00004605  /* The zipl time stamps do not match */
+
+#endif /* ERROR_H */
--- /dev/null
+++ b/zipl/boot/fba.h
@@ -0,0 +1,56 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * DASD FBA specific functions
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Stefan Haberland <stefan.haberland@de.ibm.com>
+ *
+ */
+
+#ifndef FBA_H
+#define FBA_H
+
+#include "error.h"
+#include "libc.h"
+#include "stage2.h"
+
+/* CCW COMMANDS */
+#define DASD_FBA_CCW_LOCATE	0x43
+#define DASD_FBA_CCW_LR	        0x06
+#define DASD_FBA_CCW_DE	        0x63
+#define DASD_FBA_CCW_WRITE	0x41
+#define DASD_FBA_CCW_READ	0x42
+
+#define MAX_BLOCKCT             128
+
+struct DE_fba_data {
+	struct {
+		unsigned char perm:2;   /* Permissions on this extent */
+		unsigned char zero:2;   /* Must be zero */
+		unsigned char da:1;     /* usually zero */
+		unsigned char diag:1;   /* allow diagnose */
+		unsigned char zero2:2;  /* zero */
+	} __packed mask;
+	uint8_t zero;              /* Must be zero */
+	uint16_t blk_size;         /* Blocksize */
+	uint32_t ext_loc;          /* Extent locator */
+	uint32_t ext_beg;          /* logical number of block 0 in extent */
+	uint32_t ext_end;          /* logical number of last block in extent */
+} __packed;
+
+struct LO_fba_data {
+	struct {
+		unsigned char zero:4;
+		unsigned char cmd:4;
+	} __packed operation;
+	uint8_t auxiliary;
+	uint16_t blk_ct;
+	uint32_t blk_nr;
+} __packed;
+
+struct indirect_block {
+	uint64_t *block;
+} __packed;
+
+#endif /* FBA_H */
--- a/zipl/boot/fba0.S
+++ b/zipl/boot/fba0.S
@@ -1,73 +1,46 @@
 #
-#  Ipl stage 0 loader
-#    Copyright IBM Corp. 2001, 2006.
-#    Author(s): Martin Schwidefsky (schwidefsky@de.ibm.com),
+# IPL stage 0 and 1 loader for FBA
+#
+# Copyright IBM Corp. 2001, 2012
+# Author(s): Martin Schwidefsky (schwidefsky@de.ibm.com)
+#            Michael Holzheu (holzheu@linux.vnet.ibm.com)
+#
+# Startup for IPL at address 0
+# Second stage boot loader is loaded to 0x2000 and starts at 0x2018
+#
+# The first 24 bytes are loaded by IPL to addresses 0-23 (PSW and two CCWs).
+# The CCWs on 8-23 are used as a continuation of the implicit IPL channel
+# program.
+# The 1st CCW reads block 0 again with READ IPL
+# The 2nd CCW tics to the re-loaded stage 1 IPL record.
 #
-#  startup for ipl at address 0
-#  second stage boot loader is loaded to 0x1000 and starts at 0x1008
-
-# The first 24 byes are loaded by ipl to addresses 0-23 (a PSW and two CCWs).
-# The CCWs on 8-23 are used as a continuation of the implicit ipl channel
-# program. The fba ipl loader only uses the CCW on 8-15 to load parts of the
-# the first block again starting from 0 (the reading starts again at block 0,
-# byte 0). 
-
 	.org   0x0
 	.globl _start
 _start:
-	.long  0x00080000,0x80002008           # The first 24 byte are loaded
-        .long  0x02000200,0x60000000+.Lend     # by ipl to addresses 0-23.
-        .long  0x08000000+.Ltic+512,0x40000000 # Tic to continuation
-	.long  0x00000000,0x02000000           # room for load descriptor
-        .long  0x00000000,0x00000000
-.Ltic:	.long  0x43000000+.Llo0+512,0x40000008 # locate record 0
-        .long  0x42002000,0x60000200           # bytes 0-512 of second stage
-	.long  0x43000000+.Llo1+512,0x40000008 # locate record 1
-	.long  0x42002200,0x60000200           # bytes 512-1024 of 2nd stage
-	.long  0x43000000+.Llo2+512,0x40000008 # locate record 2
-	.long  0x42002400,0x60000200           # bytes 1024-1536 of 2nd stage
-	.long  0x43000000+.Llo3+512,0x40000008 # locate record 3
-	.long  0x42002600,0x60000200           # bytes 1536-2048 of 2nd stage
-	.long  0x43000000+.Llo4+512,0x40000008 # locate record 4
-	.long  0x42002800,0x60000200           # bytes 2048-2560 of 2nd stage
-	.long  0x43000000+.Llo5+512,0x40000008 # locate record 5
-	.long  0x42002A00,0x60000200           # bytes 2560-3072 of 2nd stage
-	.long  0x43000000+.Llo6+512,0x40000008 # locate record 6
-	.long  0x42002C00,0x60000200           # bytes 3072-3584 of 2nd stage
-	.long  0x43000000+.Llo7+512,0x40000008 # locate record 7
-	.long  0x42002E00,0x60000200           # bytes 3584-4096 of 2nd stage
-	.long  0x43000000+.Llo8+512,0x40000008 # locate record 8
-	.long  0x42003000,0x60000200           # bytes 4096-4608 of 2nd stage
-	.long  0x43000000+.Llo9+512,0x40000008 # locate record 9
-	.long  0x42003200,0x60000200           # bytes 4608-5120 of 2nd stage
-	.long  0x43000000+.Llo10+512,0x40000008 # locate record 10
-	.long  0x42003400,0x60000200           # bytes 5120-5632 of 2nd stage
-	.long  0x43000000+.Llo11+512,0x40000008 # locate record 11
-	.long  0x42003600,0x60000200           # bytes 5632-6144 of 2nd stage
-	.long  0x43000000+.Llo12+512,0x40000008 # locate record 12
-	.long  0x42003800,0x60000200           # bytes 6144-6656 of 2nd stage
-	.long  0x43000000+.Llo13+512,0x40000008 # locate record 13
-	.long  0x42003A00,0x60000200           # bytes 6656-7168 of 2nd stage
-	.long  0x43000000+.Llo14+512,0x40000008 # locate record 14
-	.long  0x42003C00,0x60000200           # bytes 7168-7680 of 2nd stage
-	.long  0x43000000+.Llo15+512,0x40000008 # locate record 15
-	.long  0x42003E00,0x20000200           # bytes 7680-8192 of 2nd stage
+	.long  0x00080000,0x80002018		# The first 24 byte are loaded
+	.long  0x02000000,0x60000000+.Lend	# by ipl to addresses 0-23.
+	.long  0x08000000+.Ltic,0x40000000	# Tic to continuation
+#
+# Here starts stage 1
+#
+.Ltic:	.long  0x43000000+.Llo0,0x40000008	# locate record 0
+	.long  0x42000000,0x60000200		# bytes 0-512 of stage 1 ext
+	.long  0x43000000+.Llo1,0x40000008	# locate record 1
+	.long  0x42000000,0x60000200		# bytes 512-1024 of stage 1 ext
+	.long  0x08000000,0x00000000		# tic to stage 1b
 # offset 2 in .Llo[0-15]: block count (unsigned short) = 1
 # offset 4 in .Llo[0-15]: block number (unsigned long)
 .Llo0:	.long  0x06000001,0x00000000
 .Llo1:	.long  0x06000001,0x00000000
-.Llo2:	.long  0x06000001,0x00000000
-.Llo3:	.long  0x06000001,0x00000000
-.Llo4:	.long  0x06000001,0x00000000
-.Llo5:	.long  0x06000001,0x00000000
-.Llo6:	.long  0x06000001,0x00000000
-.Llo7:	.long  0x06000001,0x00000000
-.Llo8:	.long  0x06000001,0x00000000
-.Llo9:	.long  0x06000001,0x00000000
-.Llo10:	.long  0x06000001,0x00000000
-.Llo11:	.long  0x06000001,0x00000000
-.Llo12:	.long  0x06000001,0x00000000
-.Llo13:	.long  0x06000001,0x00000000
-.Llo14:	.long  0x06000001,0x00000000
-.Llo15:	.long  0x06000001,0x00000000
+
+	.long  0x00000000,0x00000000		# reserved
+	.long  0x00000000,0x00000000		# reserved
+	.long  0x00000000,0x00000000		# reserved
+	.long  0x00000000,0x00000000		# reserved
+
+	.long  0x00000000,0x02000000		# boot_info
+	.long  0x00000000,0x00000000
+	.long  0x00000000,0x00000000
+	.long  0x00000000,0x00000000
+	.long  0x00000000,0x00000000
 .Lend:
--- /dev/null
+++ b/zipl/boot/fba1b.S
@@ -0,0 +1,90 @@
+#
+# IPL stage 1b loader for FBA
+#
+# Copyright IBM Corp. 2001, 2012
+#
+# Author(s): Michael Holzheu (holzheu@linux.vnet.ibm.com)
+#
+# Stage 1b is loaded to 0xe000-0xe400 and is used to load stage 2 with
+# locate record/read CCWs. Currently stage 1b can load up to 24
+# blocks and therefore 12 KiB stage 2 code with 512 byte block size.
+#
+	.org   0x0
+	.globl _start
+_start:
+	.long  0x43000000+.Llo0,0x40000008  # locate record 0
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo1,0x40000008  # locate record 1
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo2,0x40000008  # locate record 2
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo3,0x40000008  # locate record 3
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo4,0x40000008  # locate record 4
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo5,0x40000008  # locate record 5
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo6,0x40000008  # locate record 6
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo7,0x40000008  # locate record 7
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo8,0x40000008  # locate record 8
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo9,0x40000008  # locate record 9
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo10,0x40000008 # locate record 10
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo11,0x40000008 # locate record 11
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo12,0x40000008 # locate record 12
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo13,0x40000008 # locate record 13
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo14,0x40000008 # locate record 14
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo15,0x40000008 # locate record 15
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo16,0x40000008 # locate record 16
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo17,0x40000008 # locate record 17
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo18,0x40000008 # locate record 18
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo19,0x40000008 # locate record 19
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo20,0x40000008 # locate record 20
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo21,0x40000008 # locate record 21
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo22,0x40000008 # locate record 22
+	.long  0x42000000,0x60000200        # read
+	.long  0x43000000+.Llo23,0x40000008 # locate record 23
+	.long  0x42000000,0x20000200        # read
+# offset 2 in .Llo[0-15]: block count (unsigned short) = 1
+# offset 4 in .Llo[0-15]: block number (unsigned long)
+.Llo0:	.long  0x06000001,0x00000000
+.Llo1:	.long  0x06000001,0x00000000
+.Llo2:	.long  0x06000001,0x00000000
+.Llo3:	.long  0x06000001,0x00000000
+.Llo4:	.long  0x06000001,0x00000000
+.Llo5:	.long  0x06000001,0x00000000
+.Llo6:	.long  0x06000001,0x00000000
+.Llo7:	.long  0x06000001,0x00000000
+.Llo8:	.long  0x06000001,0x00000000
+.Llo9:	.long  0x06000001,0x00000000
+.Llo10:	.long  0x06000001,0x00000000
+.Llo11:	.long  0x06000001,0x00000000
+.Llo12:	.long  0x06000001,0x00000000
+.Llo13:	.long  0x06000001,0x00000000
+.Llo14:	.long  0x06000001,0x00000000
+.Llo15:	.long  0x06000001,0x00000000
+.Llo16:	.long  0x06000001,0x00000000
+.Llo17:	.long  0x06000001,0x00000000
+.Llo18:	.long  0x06000001,0x00000000
+.Llo19:	.long  0x06000001,0x00000000
+.Llo20:	.long  0x06000001,0x00000000
+.Llo21:	.long  0x06000001,0x00000000
+.Llo22:	.long  0x06000001,0x00000000
+.Llo23:	.long  0x06000001,0x00000000
+.org 1024 # Stage 1b should have 1024 byte
+.Lend:
--- /dev/null
+++ b/zipl/boot/fba2.c
@@ -0,0 +1,122 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Subroutines for FBA disks.
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Stefan Haberland <stefan.haberland@de.ibm.com>
+ */
+
+#include "fba.h"
+#include "libc.h"
+#include "s390.h"
+
+int extract_length(void *data) {
+	struct linear_blockptr *blockptr = (struct linear_blockptr *)data;
+
+	return blockptr->size * (blockptr->blockct + 1);
+}
+
+int is_zero_block(void *data) {
+	struct linear_blockptr *blockptr = (struct linear_blockptr *)data;
+
+	return blockptr->blockno;
+}
+
+void *load_direct(disk_blockptr_t *data, struct subchannel_id subchannel_id,
+	    void *load_addr)
+{
+	struct linear_blockptr *blockptr = (struct linear_blockptr *)data;
+	struct DE_fba_data *de_data;
+	struct LO_fba_data *lo_data;
+	struct ccw1 *ccws;
+	unsigned long record_size;
+	int record_number;
+	struct orb orb;
+	struct irb *irb;
+	void *page;
+	int ccw_counter, lo_counter;
+
+	irb = (struct irb *)&S390_lowcore.irb;
+
+restart:
+	/*
+	 * allocate one page for:
+	 *    16 byte de_data
+	 *    128 * 8 Byte lo_data
+	 *    128 * 8 Byte ccws
+	 *
+	 * = 2064 Byte used
+	 */
+	page = (void *)get_zeroed_page();
+	de_data = (struct DE_fba_data *)page;
+	lo_data	= (struct LO_fba_data *)(page + sizeof(struct DE_fba_data));
+	ccws = (struct ccw1 *)(page + sizeof(struct DE_fba_data) +
+			       128 * sizeof(struct LO_fba_data));
+
+	ccw_counter = 0;
+	lo_counter = 0;
+	memset(irb, 0, sizeof(struct irb));
+	memset(&orb, 0, sizeof(struct orb));
+
+	if (blockptr->blockct > MAX_BLOCKCT) {
+		record_number = MAX_BLOCKCT - 1;
+		blockptr->blockct -= MAX_BLOCKCT;
+	} else {
+		record_number = blockptr->blockct;
+		blockptr->blockct -= record_number;
+	}
+
+	record_size = blockptr->size;
+
+	/* initialise DEFINE_EXTENT */
+	ccws[0].cmd_code = DASD_FBA_CCW_DE;
+	ccws[0].flags = CCW_FLAG_CC;
+	ccws[0].count = 16;
+	de_data->mask.perm = 0x1;
+	de_data->blk_size = blockptr->size;
+	de_data->ext_loc = blockptr->blockno;
+	ccws[0].cda = (uint32_t) (unsigned long) de_data;
+	ccw_counter++;
+
+	/* add 1 LO and 1 READ CCW per block */
+	while (1) {
+		/* initialise LOCATE_RECORD */
+		ccws[ccw_counter].cmd_code = DASD_FBA_CCW_LOCATE;
+		ccws[ccw_counter].flags = CCW_FLAG_CC;
+		ccws[ccw_counter].count = 8;
+		lo_data[lo_counter].operation.cmd = 0x6;
+		lo_data[lo_counter].blk_nr = lo_counter;
+		de_data->ext_end = lo_counter;
+		lo_data[lo_counter].blk_ct = 1;
+		ccws[ccw_counter].cda = (unsigned long) &lo_data[lo_counter];
+		lo_counter++;
+		ccw_counter++;
+
+		/* initialise READ_CCW */
+		ccws[ccw_counter].cmd_code = DASD_FBA_CCW_READ;
+		ccws[ccw_counter].count = record_size;
+		ccws[ccw_counter].cda = (uint32_t) (unsigned long) load_addr;
+		ccw_counter++;
+
+		blockptr->blockno++;
+		record_number--;
+		load_addr += record_size;
+
+		if (record_number >= 0)
+			ccws[ccw_counter-1].flags |= CCW_FLAG_CC;
+		else
+			break;
+	}
+
+	orb.fmt = 1;
+	orb.cpa = (uint32_t) (unsigned long) ccws;
+
+	start_io(subchannel_id, irb, &orb);
+	free_page((unsigned long)page);
+
+	if (blockptr->blockct > 0)
+		goto restart;
+
+	return load_addr;
+}
--- /dev/null
+++ b/zipl/boot/fba2dump.c
@@ -0,0 +1,186 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Single-volume FBA DASD dump tool
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Michael Holzheu <holzheu@linux.vnet.ibm.com>
+ */
+
+#include "stage2dump.h"
+#include "error.h"
+#include "fba.h"
+
+#define BLK_PWRT	64	/* Blocks per write */
+#define BLK_SIZE	0x200	/* FBA block size */
+
+/*
+ * Magic number at start of dump record
+ */
+uint64_t magic __attribute__((section(".stage2.head")))
+	= 0x5a44464241363403ULL; /* ZDFBA64, version 3 */
+
+/*
+ * FBA dump device partition specification
+ */
+static struct {
+	unsigned int blk_start;
+	unsigned int blk_end;
+} device;
+
+/*
+ * ORB / IRB
+ */
+static struct orb orb = {
+	.intparm	= 0x0049504c,	/* Interruption Parameter */
+	.fmt		= 0x1,		/* Use format 1 CCWs */
+	.c64		= 0x1,		/* Use IDAs */
+	.lpm		= 0xff,		/* Logical path mask */
+};
+
+static struct irb irb;
+
+/*
+ * Data for Locate Record CCW
+ */
+static struct LO_fba_data lodata = {
+	.operation = {
+		.cmd = 0x1,
+	},
+};
+
+/*
+ * Data for Define Extend CCW
+ */
+static struct DE_fba_data dedata = {
+	.mask = {
+		.perm	= 0x3,
+	},
+	.blk_size	= 0x200,
+};
+
+/*
+ * CCW program and IDA list
+ */
+static struct {
+	struct ccw1 deccw;
+	struct ccw1 loccw;
+	struct ccw1 wrccw;
+	unsigned long ida_list[BLK_PWRT * BLK_SIZE / 4096];
+} ccw_program __aligned(8);
+
+/*
+ * FBA parameter block passed by zipl
+ */
+struct fba_dump_param {
+	uint32_t	res1;
+	uint32_t	blk_start;
+	uint32_t	res2;
+	uint32_t	blk_end;
+} __packed;
+
+/*
+ * Convert memory size to number of blocks
+ */
+static inline unsigned long m2b(unsigned long mem)
+{
+	return mem / BLK_SIZE;
+}
+
+/*
+ * Convert number of blocks to memory size
+ */
+static inline unsigned long b2m(unsigned long blk)
+{
+	return blk * BLK_SIZE;
+}
+
+/*
+ * Get device characteristics from zipl parameter block
+ */
+void dt_device_parm_setup(void)
+{
+	struct fba_dump_param *param = (void *) __stage2_desc;
+
+	device.blk_start = param->blk_start;
+	device.blk_end = param->blk_end;
+}
+
+/*
+ * Enable DASD device
+ */
+void dt_device_enable(void)
+{
+	io_irq_enable();
+	set_device(IPL_SC, ENABLED);
+}
+
+/*
+ * Write memory with number of blocks to start block
+ */
+static void writeblock(unsigned long blk, unsigned long addr, unsigned long blk_count,
+		       unsigned long zero_page)
+{
+	unsigned long blk_end;
+
+	blk_end = blk + blk_count;
+	if (blk_end >= device.blk_end)
+		panic(EMEM, "Device too small");
+	ccw_program.wrccw.count = b2m(blk_count);
+	lodata.blk_ct = blk_count;
+	lodata.blk_nr = blk;
+	create_ida_list(ccw_program.ida_list, b2m(blk_count), addr, zero_page);
+	start_io(IPL_SC, &irb, &orb);
+}
+
+/*
+ * Initialize the CCW program
+ */
+static void ccw_program_init(void)
+{
+	ccw_program.deccw.cmd_code = DASD_FBA_CCW_DE;
+	ccw_program.deccw.flags = CCW_FLAG_CC;
+	ccw_program.deccw.count = 0x0010;
+	ccw_program.deccw.cda = __pa32(&dedata);
+
+	ccw_program.loccw.cmd_code = DASD_FBA_CCW_LOCATE;
+	ccw_program.loccw.flags = CCW_FLAG_CC;
+	ccw_program.loccw.count = 0x0008;
+	ccw_program.loccw.cda = __pa32(&lodata);
+
+	ccw_program.wrccw.cmd_code = DASD_FBA_CCW_WRITE;
+	ccw_program.wrccw.flags = CCW_FLAG_IDA | CCW_FLAG_SLI;
+	ccw_program.wrccw.cda = __pa32(ccw_program.ida_list);
+
+	orb.cpa = __pa32(&ccw_program);
+	dedata.ext_end = device.blk_end;
+}
+
+/*
+ * Dump all memory to DASD partition
+ */
+void dt_dump_mem(void)
+{
+	unsigned long blk, addr, page;
+
+	ccw_program_init();
+	blk = device.blk_start;
+	page = get_zeroed_page();
+
+	/* Write dump header */
+	writeblock(blk, __pa(dump_hdr), m2b(DF_S390_HDR_SIZE), 0);
+	blk += DF_S390_HDR_SIZE / BLK_SIZE;
+
+	/* Write memory */
+	for (addr = 0; addr < dump_hdr->mem_size; addr += b2m(BLK_PWRT)) {
+		writeblock(blk, addr, BLK_PWRT, page);
+		progress_print(addr);
+		blk += BLK_PWRT;
+	}
+	progress_print(addr);
+
+	/* Write end marker */
+	df_s390_em_page_init(page);
+	writeblock(blk, page, 1, 0);
+	free_page(page);
+}
--- /dev/null
+++ b/zipl/boot/head.S
@@ -0,0 +1,27 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Entry code for stage 2 and stage 3 boot loader
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Michael Holzheu  <holzheu@linux.vnet.ibm.com>
+ *            Stefan Haberland <stefan.haberland@de.ibm.com>
+ */
+
+.section .text.start
+.globl _start
+_start:
+	basr	%r13,0
+0:	la	%r7,2				/* First try code 2: */
+	la	%r6,0				/* 64 bit psws are restored */
+	sigp	%r7,%r6,0x12			/* Switch to 64 bit */
+	bc	8,.Lswitched_64-0b(%r13)	/* Accepted ? */
+	la	%r7,1				/* Failed - try code 1 */
+	sigp	%r7,%r6,0x12			/* Switch to 64 bit */
+.Lswitched_64:
+	sam64					/* Switch to 64 bit addr mode */
+	basr	%r13,0
+1:	llgf	%r15,.Lstack-1b(%r13)		/* End of stack */
+	brasl	%r14,initialize
+.Lstack: .long  0x10000-160
+.previous
--- /dev/null
+++ b/zipl/boot/kdump.c
@@ -0,0 +1,37 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Stand-alone kdump support
+ *
+ * Copyright IBM Corp. 2013
+ */
+
+#include "libc.h"
+#include "error.h"
+#include "menu.h"
+#include "kdump.h"
+#include "s390.h"
+
+void kdump_failed(unsigned long reason)
+{
+	panic(reason, "Dump failed: Check disabled wait code");
+}
+
+void os_info_check(struct os_info *os_info)
+{
+	if (os_info == NULL)
+		kdump_failed(EOS_INFO_MISSING);
+	if (((unsigned long) os_info) % PAGE_SIZE)
+		kdump_failed(EOS_INFO_MISSING);
+	if (!page_is_valid((unsigned long) os_info))
+		kdump_failed(EOS_INFO_MISSING);
+	if (os_info->magic != OS_INFO_MAGIC)
+		kdump_failed(EOS_INFO_MISSING);
+	if (csum_partial(&os_info->version_major, OS_INF0_CSUM_SIZE, 0) !=
+	    os_info->csum)
+		kdump_failed(EOS_INFO_CSUM_FAILED);
+	if (os_info->version_major > OS_INFO_VERSION_MAJOR_SUPPORTED)
+		kdump_failed(EOS_INFO_VERSION);
+	if (os_info->crashkernel_addr == 0)
+		kdump_failed(EOS_INFO_NOCRASHKERNEL);
+}
--- /dev/null
+++ b/zipl/boot/kdump.h
@@ -0,0 +1,43 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Stand-alone kdump definitions
+ *
+ * Copyright IBM Corp. 2013
+ */
+
+
+#ifndef KDUMP_H
+#define KDUMP_H
+
+#include "libc.h"
+#include "s390.h"
+
+#define OS_INFO_VERSION_MAJOR_SUPPORTED	1
+#define OS_INFO_MAGIC			0x4f53494e464f535aULL /* OSINFOSZ */
+#define OS_INF0_CSUM_SIZE		4084
+
+#define OS_INFO_VMCOREINFO		0
+#define OS_INFO_REIPL_BLOCK		1
+
+struct os_info_entry {
+	uint64_t addr;
+	uint64_t size;
+	uint32_t csum;
+} __packed;
+
+struct os_info {
+	uint64_t magic;
+	uint32_t csum;
+	uint16_t version_major;
+	uint16_t version_minor;
+	uint64_t crashkernel_addr;
+	uint64_t crashkernel_size;
+	struct os_info_entry entry[2];
+	uint8_t reserved[4024];
+} __packed;
+
+void os_info_check(struct os_info *os_info);
+void kdump_failed(unsigned long reason);
+
+#endif /* KDUMP_H */
--- /dev/null
+++ b/zipl/boot/kdump2.c
@@ -0,0 +1,46 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Stand-alone kdump support (stage 2)
+ *
+ * Copyright IBM Corp. 2013
+ */
+
+#include "libc.h"
+#include "stage2.h"
+#include "error.h"
+#include "menu.h"
+#include "kdump.h"
+
+static struct os_info **lc_os_info = ((struct os_info **)&S390_lowcore.os_info);
+
+/*
+ * Copy crashkernel memory from [0, crash size] to
+ * [crash base, crash base + crash size] if config_nr specifies a
+ * kdump boot menu entry.
+ *
+ * Parameter:
+ *   Config number (starts with 1)
+ */
+void kdump_stage2(unsigned long config_nr)
+{
+	struct os_info *os_info = *lc_os_info;
+	unsigned long crash_size;
+	void *crash_base;
+
+	if (!(__stage2_params.config_kdump & (0x1 << config_nr)))
+		return;
+	os_info_check(os_info);
+
+	/* Copy crashkernel memory */
+	crash_base = (void *) os_info->crashkernel_addr;
+	crash_size = os_info->crashkernel_size;
+	memcpy(crash_base, NULL, crash_size);
+	/*
+	 * Relocate OS info pointer if necessary (needed for stage 3)
+	 * If OS info is smaller than crash size then add crash base
+	 */
+	if (__pa(os_info) >= crash_size)
+		return;
+	*lc_os_info = (void *) __pa(os_info) + __pa(crash_base);
+}
